package cn.kdan.cloud.pdf.office.payment.webhook;

import cn.kdan.cloud.pdf.office.api.payment.dto.SubscriptionNotification;
import cn.kdan.cloud.pdf.office.api.payment.enums.SubscriptionNotificationType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author ComPDFKit-WPH 2023/6/20
 */
@RestController
public class AppStoreWebhookMonitor {

    @RequestMapping(value = "/subscription", method = RequestMethod.POST)
    public ResponseEntity<String> receiveSubscriptionCallback(@RequestBody String body) {
        // 解析回调请求，获取相关参数
        SubscriptionNotification notification = new SubscriptionNotification(body);

        // 访问App Store服务器，验证回调请求的有效性
        boolean isValid = notification.verifyReceipt();

        // 根据验证结果和回调类型进行处理
        if (isValid) {
//            SubscriptionNotificationType notificationType = notification.getNotificationType();
//            if (SubscriptionNotificationType.CANCEL.equals(notificationType)) {
//                // 处理取消订阅相关的回调
//                // TODO: 实现具体的处理逻辑
//            } else if (SubscriptionNotificationType.RENEWAL.equals(notificationType)) {
//                // 处理续订相关的回调
//                // TODO: 实现具体的处理逻辑
//            } else if (SubscriptionNotificationType.INTERACTIVE_RENEWAL.equals(notificationType)) {
//                // 处理互动续订相关的回调
//                // TODO: 实现具体的处理逻辑
//            } else if (SubscriptionNotificationType.DID_CHANGE_RENEWAL_PREF.equals(notificationType)) {
//                // 处理续订首选项改变相关的回调
//                // TODO: 实现具体的处理逻辑
//            } else if (SubscriptionNotificationType.DID_CHANGE_RENEWAL_STATUS.equals(notificationType)) {
//                // 处理续订状态改变相关的回调
//                // TODO: 实现具体的处理逻辑
//            }
        } else {
            // 验证失败，记录错误日志
            // TODO: 记录错误日志
        }

        // 返回200 OK响应
        return ResponseEntity.ok().build();
    }
}