package cn.kdan.cloud.pdf.office.website.service;

import cn.kdan.cloud.pdf.office.api.payment.dto.AppStoreOrderSucceedDTO;
import cn.kdan.cloud.pdf.office.api.payment.dto.CreatOrderDTO;
import cn.kdan.cloud.pdf.office.api.payment.vo.CreatOrderResultVO;
import cn.kdan.cloud.pdf.office.api.payment.vo.SubscriptionSchemeVO;
import cn.kdan.cloud.pdf.office.api.product.enums.PlatformEnum;
import cn.kdan.cloud.pdf.office.common.pojo.ResultMap;
import cn.kdan.cloud.pdf.office.website.dto.IsSubscriptionDTO;

import java.time.LocalDateTime;

/**
 * @author ComPDFKit-WPH 2023/2/9
 * @eo.api-type http
 * @eo.groupName 默认分组
 * @eo.path
 */
public interface PaymentService {

    /**
     * 获取订单记录
     *
     * @return SubscriptionSchemeVO
     */
    ResultMap<SubscriptionSchemeVO> getSubscriptionSchemeInfo(String appId);

    /**
     * 获取订阅结束时间
     *
     * @param platform 平台
     * @return LocalDateTime
     */
    LocalDateTime getSubscriptionEndDate(Integer platform);

    /**
     * 创建订单
     *
     * @param creatOrderDTO creatOrderDTO
     * @return url
     */
    String creatOrder(CreatOrderDTO creatOrderDTO);

    /**
     * 订单支付成功（applePay专用）
     * 回传appal pay id &签名证书
     *
     * @param appStoreOrderSucceed appStoreOrderSucceed
     * @return Void
     */
    void appStoreOrderSucceed(AppStoreOrderSucceedDTO appStoreOrderSucceed);

    /**
     * 判断是否有订阅
     *
     * @param isSubscriptionDTO isSubscriptionDTO
     * @return Boolean true: 折扣，false：原价
     */
    boolean isSubscription(IsSubscriptionDTO isSubscriptionDTO);

    /**
     * 取消订阅
     * @param productId 产品id
     * @return
     */
    void cancelSubscription(String productId);

    /**
     * 创建订单（applePay专用）
     *
     * @param creatOrderDTO creatOrderDTO
     * @return CreatOrderResultVO
     */
    CreatOrderResultVO appStoreCreateOrder(CreatOrderDTO creatOrderDTO);
}
